/**
 * Copyright (c) 2009-2012 EBM WebSourcing, 2012-2015 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see <http://www.gnu.org/licenses/>
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.launcher.api.service;

import java.util.List;

import javax.xml.namespace.QName;

import org.w3c.dom.Document;

/**
 * The petals service endpoint definition.
 * @author Christophe Hamerling - EBM WebSourcing
 */
public interface ServiceEndpoint {

    public enum EndpointType {
        CONSUMER, EXTERNAL, INTERNAL, LINKED
    }

    EndpointType getType();

    void setType(EndpointType type);

    /**
     * 
     * @return
     */
    String getEndpointName();

    /**
     * 
     * @return
     */
    QName getServiceName();

    /**
     * 
     * @return
     */
    List<QName> getInterfacesName();

    /**
     * 
     * @return
     */
    Document getDescription();

    /**
     * 
     * @return
     */
    Location getLocation();
}
